Index: code/branches/kicklib/src/orxonox/MoodManager.cc
===================================================================
--- code/branches/kicklib/src/orxonox/MoodManager.cc	(revision 7984)
+++ code/branches/kicklib/src/orxonox/MoodManager.cc	(revision 8071)
@@ -50,10 +50,13 @@
 
         // Checking for the existence of the folder for the default mood
-        const std::string& path = "ambient/" + MoodManager::defaultMood_ + "/.";
-        if (!Resource::exists(path))
+        const std::string& patha = "ambient/" + MoodManager::defaultMood_ + "/.";
+        if (!Resource::exists(patha))
         {
             // TODO: Non-fatal error handling (non-critical resource missing)
             COUT(2) << "Mood Warning: Folder for default mood (" << MoodManager::defaultMood_ << ") does not exist!" << std::endl;
         }
+        
+        // @TODO
+        // Creating a vector of the available moods to enable easy mood selection by Lua/CEGUI        
     }
 
Index: code/branches/kicklib/src/orxonox/OrxonoxPrereqs.h
===================================================================
--- code/branches/kicklib/src/orxonox/OrxonoxPrereqs.h	(revision 7984)
+++ code/branches/kicklib/src/orxonox/OrxonoxPrereqs.h	(revision 8071)
@@ -53,8 +53,11 @@
 #    endif
 #  endif
-#elif defined ( ORXONOX_GCC_VISIBILITY )
+#  define _OrxonoxPrivate
+#elif defined (ORXONOX_GCC_VISIBILITY)
 #  define _OrxonoxExport  __attribute__ ((visibility("default")))
+#  define _OrxonoxPrivate __attribute__ ((visibility("hidden")))
 #else
 #  define _OrxonoxExport
+#  define _OrxonoxPrivate
 #endif
 
Index: code/branches/kicklib/src/orxonox/sound/AmbientSound.cc
===================================================================
--- code/branches/kicklib/src/orxonox/sound/AmbientSound.cc	(revision 7984)
+++ code/branches/kicklib/src/orxonox/sound/AmbientSound.cc	(revision 8071)
@@ -42,5 +42,5 @@
 
         // Ambient sounds always fade in
-        this->setVolume(0);
+        this->setVolume(0.0f);
     }
 
Index: code/branches/kicklib/src/orxonox/sound/BaseSound.cc
===================================================================
--- code/branches/kicklib/src/orxonox/sound/BaseSound.cc	(revision 7984)
+++ code/branches/kicklib/src/orxonox/sound/BaseSound.cc	(revision 8071)
@@ -31,5 +31,10 @@
 #include <cassert>
 #include <vector>
+
+#ifdef ORXONOX_PLATFORM_APPLE
+#include "openal/al.h"
+#else
 #include <al.h>
+#endif
 
 #include "util/Math.h"
Index: code/branches/kicklib/src/orxonox/sound/SoundBuffer.cc
===================================================================
--- code/branches/kicklib/src/orxonox/sound/SoundBuffer.cc	(revision 7984)
+++ code/branches/kicklib/src/orxonox/sound/SoundBuffer.cc	(revision 8071)
@@ -30,5 +30,9 @@
 #include "SoundBuffer.h"
 
+#if defined(ORXONOX_PLATFORM_APPLE)
+#include <ALUT/alut.h>
+#else
 #include <AL/alut.h>
+#endif
 #include <vorbis/vorbisfile.h>
 
Index: code/branches/kicklib/src/orxonox/sound/SoundManager.cc
===================================================================
--- code/branches/kicklib/src/orxonox/sound/SoundManager.cc	(revision 7984)
+++ code/branches/kicklib/src/orxonox/sound/SoundManager.cc	(revision 8071)
@@ -31,5 +31,9 @@
 #include "SoundManager.h"
 
+#if defined(__APPLE__)
+#include <ALUT/alut.h>
+#else
 #include <AL/alut.h>
+#endif
 #include <utility>
 #include <loki/ScopeGuard.h>
@@ -73,10 +77,13 @@
         this->bDestructorCalled_ = false;
 
+        // Clear error messages (might be problematic on some systems)
+        alGetError();
+        alutGetError();
+
         // See whether we even want to load
         bool bDisableSound_ = false;
         SetConfigValue(bDisableSound_, false);
         if (bDisableSound_)
-            ThrowException(InitialisationAborted, "Sound: Not loading at all");
-
+            ThrowException(InitialisationAborted, "Sound: Not loading at all");        
         if (!alutInitWithoutContext(NULL, NULL))
             ThrowException(InitialisationFailed, "Sound Error: ALUT initialisation failed: " << alutGetErrorString(alutGetError()));
@@ -126,8 +133,8 @@
         GameMode::setPlaysSound(true);
         Loki::ScopeGuard resetPlaysSoundGuard = Loki::MakeGuard(&GameMode::setPlaysSound, false);
-
+        
         // Get some information about the sound
         if (const char* version = alGetString(AL_VERSION))
-            COUT(4) << "Sound: --- OpenAL Version: " << version << std::endl;
+            COUT(4) << "Sound: --- OpenAL Version: " << version << std::endl;            
         if (const char* vendor = alGetString(AL_VENDOR))
             COUT(4) << "Sound: --- OpenAL Vendor : " << vendor << std::endl;
Index: code/branches/kicklib/src/orxonox/sound/SoundStreamer.cc
===================================================================
--- code/branches/kicklib/src/orxonox/sound/SoundStreamer.cc	(revision 7984)
+++ code/branches/kicklib/src/orxonox/sound/SoundStreamer.cc	(revision 8071)
@@ -27,5 +27,10 @@
 #include "SoundStreamer.h"
 
+#ifdef ORXONOX_PLATFORM_APPLE
+#include "openal/al.h"
+#else
 #include <al.h>
+#endif
+
 #include <vorbis/vorbisfile.h>
 #include "SoundManager.h"
Index: code/branches/kicklib/src/orxonox/sound/WorldSound.cc
===================================================================
--- code/branches/kicklib/src/orxonox/sound/WorldSound.cc	(revision 7984)
+++ code/branches/kicklib/src/orxonox/sound/WorldSound.cc	(revision 8071)
@@ -30,5 +30,9 @@
 #include "WorldSound.h"
 
+#if defined(__APPLE__)
+#include <ALUT/alut.h>
+#else
 #include <AL/alut.h>
+#endif
 #include "util/Math.h"
 #include "core/CoreIncludes.h"